Subject: Re: bug#23648: [PATCH] `defun-declarations-alist' can be unintentionally modified

From: Eli Zaretskii <[email-masked]>
Date: Mon, 18 Jul 2016 21:16:00 +0300

> From: Noam Postavsky <[email-masked]>
> Date: Mon, 18 Jul 2016 11:53:42 -0400
> Cc: Paul Pogonyshev <[email-masked]>, [email-masked]
> 
> > I'm not sure, actually.  How probable is the situation where this
> > problem pops up?
> 
> It happens with 100% probability when performing completion inside a
> (declare ...) form. Starting from emacs -Q, put into *scratch*
> 
> (defun foo ()
>   (declare (indent 1))
>   nil)
> 
> Macroexpanding this gives:
> 
> (prog1
>     (defalias 'foo
>       #'(lambda nil nil))
>   (put 'foo 'lisp-indent-function '1))
> 
> Now move point to just after "indent" and type C-M-i (this gives
> message "Sole completion"), macroexpanding now gives
> 
> (prog1
>     (defalias 'foo
>       #'(lambda nil nil))
>   "Warning: Unknown defun property `indent' in foo")

Sorry, I'm not following: what do you mean by "macroexpanding" in this
context?  When you wrote "when performing completion", I expected to
see some simple completion gesture that leads to an error, but it
sounds like I'm missing something.

> >  And when was the bug introduced?
> 
> Code seems to have been that way since it was introduced in 24.4:
> dd8791e9 "* lisp/emacs-lisp/lisp.el (lisp-completion-at-point):
> Provide specialized
> completion tables when completing error conditions and
> `declare' arguments...."

Thanks.